#
# File:		makedocs.mak
# Author:	Julian Smart
# Created:	1997
# Updated:	
# Copyright:	
#
# "%W% %G%"
#
# Makefile : Builds wxWindows documents
#

WXDIR = $(WXWIN)
THISDIR = $(WXWIN)\distrib

MAKEINDEX=makeindx
DVIPS=dvips
DOLATEX=$(WXWIN)\distrib\dolatex
DODVIPS=$(WXWIN)\distrib\dodvips

.SUFFIXES:  .tex .ps .dvi .xlp .rtf .hlp

.tex.dvi:
        $(DOLATEX) $*

.dvi.ps:
        $(DODVIPS) $*

allps:  wxps faqps techrefps refps propps wxchartps wxgridps wxhelpps wxhelp2ps wxbuildps\
 dialogedps wxtabps hytextps tex2rtfps prologiops wxtreeps wxgraphps installps oglps

wxps: $(WXDIR)\docs\manual.ps
refps: $(WXDIR)\docs\referenc.ps
faqps: $(WXDIR)\docs\faq.ps
techrefps: $(WXDIR)\docs\techref.ps

propps: $(WXDIR)\utils\wxprop\docs\prop.ps
wxchartps: $(WXDIR)\utils\wxchart\docs\wxchart.ps
wxgridps: $(WXDIR)\utils\wxgrid\docs\wxgrid.ps
wxhelpps: $(WXDIR)\utils\wxhelp\docs\manual.ps
wxhelp2ps: $(WXDIR)\utils\wxhelp2\docs\manual.ps
wxbuildps: $(WXDIR)\utils\wxbuild\docs\wxbuild.ps
dialogedps: $(WXDIR)\utils\dialoged\docs\dialoged.ps
wxtabps: $(WXDIR)\utils\wxtab\docs\wxtab.ps
hytextps: $(WXDIR)\utils\hytext\docs\manual.ps
tex2rtfps: $(WXDIR)\utils\tex2rtf\docs\tex2rtf.ps
prologiops: $(WXDIR)\utils\prologio\docs\manual.ps
wxtreeps: $(WXDIR)\utils\wxtree\docs\manual.ps
wxgraphps: $(WXDIR)\utils\wxgraph\docs\manual.ps
installps: $(WXDIR)\utils\winstall\docs\install.ps
oglps: $(WXDIR)\utils\ogl\docs\ogl.ps


$(WXDIR)\docs\manual.dvi:	$(WXDIR)\docs\manual.tex $(WXDIR)\docs\body.tex
$(WXDIR)\docs\manual.ps:	$(WXDIR)\docs\manual.dvi

$(WXDIR)\docs\referenc.dvi:	$(WXDIR)\docs\referenc.tex $(WXDIR)\docs\classes.tex $(WXDIR)\docs\topics.tex\
 $(WXDIR)\docs\wxstring.tex
$(WXDIR)\docs\referenc.ps:	$(WXDIR)\docs\referenc.dvi

$(WXDIR)\docs\faq.ps:	$(WXDIR)\docs\faq.dvi
$(WXDIR)\docs\faq.dvi:	$(WXDIR)\docs\faq.tex

$(WXDIR)\docs\techref.ps:	$(WXDIR)\docs\techref.dvi
$(WXDIR)\docs\techref.dvi:	$(WXDIR)\docs\techref.tex

$(WXDIR)\utils\wxprop\docs\prop.ps:	$(WXDIR)\utils\wxprop\docs\prop.dvi
$(WXDIR)\utils\wxprop\docs\prop.dvi:	$(WXDIR)\utils\wxprop\docs\prop.tex

$(WXDIR)\utils\wxchart\docs\wxchart.ps:	$(WXDIR)\utils\wxchart\docs\wxchart.dvi
$(WXDIR)\utils\wxchart\docs\wxchart.dvi:	$(WXDIR)\utils\wxchart\docs\wxchart.tex

$(WXDIR)\utils\wxgrid\docs\wxgrid.ps:	$(WXDIR)\utils\wxgrid\docs\wxgrid.dvi
$(WXDIR)\utils\wxgrid\docs\wxgrid.dvi:	$(WXDIR)\utils\wxgrid\docs\wxgrid.tex

$(WXDIR)\utils\wxhelp\docs\manual.ps:	$(WXDIR)\utils\wxhelp\docs\manual.dvi
$(WXDIR)\utils\wxhelp\docs\manual.dvi:	$(WXDIR)\utils\wxhelp\docs\manual.tex

$(WXDIR)\utils\wxhelp2\docs\manual.ps:	$(WXDIR)\utils\wxhelp2\docs\manual.dvi
$(WXDIR)\utils\wxhelp2\docs\manual.dvi:	$(WXDIR)\utils\wxhelp2\docs\manual.tex

$(WXDIR)\utils\wxbuild\docs\wxbuild.ps:	$(WXDIR)\utils\wxbuild\docs\wxbuild.dvi
$(WXDIR)\utils\wxbuild\docs\wxbuild.dvi:	$(WXDIR)\utils\wxbuild\docs\wxbuild.tex

$(WXDIR)\utils\dialoged\docs\dialoged.ps:	$(WXDIR)\utils\dialoged\docs\dialoged.dvi
$(WXDIR)\utils\dialoged\docs\dialoged.dvi:	$(WXDIR)\utils\dialoged\docs\dialoged.tex

$(WXDIR)\utils\wxtab\docs\wxtab.ps:	$(WXDIR)\utils\wxtab\docs\wxtab.dvi
$(WXDIR)\utils\wxtab\docs\wxtab.dvi:	$(WXDIR)\utils\wxtab\docs\wxtab.tex

$(WXDIR)\utils\hytext\docs\manual.ps:	$(WXDIR)\utils\hytext\docs\manual.dvi
$(WXDIR)\utils\hytext\docs\manual.dvi:	$(WXDIR)\utils\hytext\docs\manual.tex

$(WXDIR)\utils\tex2rtf\docs\tex2rtf.ps:	$(WXDIR)\utils\tex2rtf\docs\tex2rtf.dvi
$(WXDIR)\utils\tex2rtf\docs\tex2rtf.dvi:	$(WXDIR)\utils\tex2rtf\docs\tex2rtf.tex

$(WXDIR)\utils\prologio\docs\manual.ps:	$(WXDIR)\utils\prologio\docs\manual.dvi
$(WXDIR)\utils\prologio\docs\manual.dvi:	$(WXDIR)\utils\prologio\docs\manual.tex

$(WXDIR)\utils\wxtree\docs\manual.ps:	$(WXDIR)\utils\wxtree\docs\manual.dvi
$(WXDIR)\utils\wxtree\docs\manual.dvi:	$(WXDIR)\utils\wxtree\docs\manual.tex

$(WXDIR)\utils\wxgraph\docs\manual.ps:	$(WXDIR)\utils\wxgraph\docs\manual.dvi
$(WXDIR)\utils\wxgraph\docs\manual.dvi:	$(WXDIR)\utils\wxgraph\docs\manual.tex

$(WXDIR)\utils\winstall\docs\install.ps:	$(WXDIR)\utils\winstall\docs\install.dvi
$(WXDIR)\utils\winstall\docs\install.dvi:	$(WXDIR)\utils\winstall\docs\install.tex

$(WXDIR)\utils\ogl\docs\ogl.ps:	$(WXDIR)\utils\ogl\docs\ogl.dvi
$(WXDIR)\utils\ogl\docs\ogl.dvi:	$(WXDIR)\utils\ogl\docs\ogl.tex $(WXDIR)\utils\ogl\docs\classes.tex


